#cs ----------------------------------------------------------------------------

	AutoIt Version: 3.3.6.1
	Author:         	Peter Murr
	pcfreak -at- pcfreak -dot- de

	Script Function:
	Modifiziert eine "FRITZ!Box-Fernzugang einrichten" Konfiguration so,
	dass ein iOS-Gert oder MAC (oder andere IPSec Clients) eine Verbindung
	zur FRITZ!Box aufbauen knnen.
	Es ist dann kein spezieller Client mehr erforderlich!

#ce ----------------------------------------------------------------------------
;quick and dirty code!

; Script Start - Add your code below here
#include<array.au3>
#include <file.au3>
Dim $aCfgArray
$done = 0
$sCFGFile = FileOpenDialog("FRITZ!Box VPN Konfigurationsdatei", @AppDataDir & "\AVM\FRITZ!Fernzugang\", "FRITZ!-Fernzugang File (*.cfg)", 1 + 3, "")
If @error Then
	MsgBox(4096, "", "Keine Datei gewhlt!" & @CRLF & "Programm wird beendet!")
	Exit
EndIf
$sCFGFileout = StringTrimRight($sCFGFile, 4) & "_IPSec.cfg"

; Benutzername abfragen
$username = InputBox("Zugangsdaten", "Benutzer : ", "")
$password = InputBox("Zugangsdaten", "Passwort : ", "")
$preshared = InputBox("Zugangsdaten", "Preshared Key : ", "")
if (($username = "") or ($password = "") or ($preshared = "")) Then
	MsgBox(0, "Fehler", "Benuter, Passwort oder Preshared Key war leer" & @CRLF & "Programm wird beendet!")
	Exit
EndIf
if (StringLen($preshared) < 20) Then

	If Not IsDeclared("iMsgBoxAnswer") Then Local $iMsgBoxAnswer
	$iaMsgBoxAnswer = MsgBox(308, "Preshared Key", "Ihr Preshared Key ist unter 20 Zeichen." & @CRLF & "Das ist eine massive Sicherheitslcke!" & @CRLF & "Wollen sie wirklich mit diesem kurzen Schlssel fortfahren?")
	Select
		Case $iaMsgBoxAnswer = 6 ;Yes

		Case $iaMsgBoxAnswer = 7 ;No
			Exit
	EndSelect

EndIf


If Not IsDeclared("iMsgBoxAnswer") Then Local $iMsgBoxAnswer
$iMsgBoxAnswer = MsgBox(36, "Zugriffsberechtigung", "Soll der komplette Internetverkehr ber den VPN Tunnel geleitet werden?" & @CRLF & "(Erfordert Firmware xx.04.86 oder hher!)")


;file in Array lesen
_FileReadToArray($sCFGFile, $aCfgArray)


;einzeilige Ersetzungen durchfhren fr user_fqdn->key_id key use_xauth no/yes
For $a = 1 to (UBound($aCfgArray) - 1)
	;user_fqdn ersetzen mit key_id
	$find1 = StringRegExp($aCfgArray[$a], "(.*user_fqdn\s=\s.*;)", 0, 1)
	If $find1 = 1 Then
		$aCfgArray[$a] = StringReplace($aCfgArray[$a], "user_fqdn", "key_id", 1, 1)
		If @extended = 1 Then $done = $done + 1
	EndIf
	;key = "xx"; ersetzen mit key = "preshared key aus Eingabe";
	$find2 = StringRegExp($aCfgArray[$a], "(.*key\s=\s.*;)", 0, 1) ; nur Zeile finden (brauchen wir spter)
	If $find2 = 1 Then
		$aCfgArray[$a] = "                key = " & Chr(34) & $preshared & Chr(34) & ";"
		$done = $done + 1
	EndIf
	; use xauth von no auf yes setzen
	$find3 = StringRegExp($aCfgArray[$a], "(.*use_xauth\s=\sno;)", 0, 1)
	If $find3 = 1 Then
		$aCfgArray[$a] = StringReplace($aCfgArray[$a], "no;", "yes;", 1, 1)
		If @extended = 1 Then $done = $done + 1
	EndIf
	; pfs --> no-pfs
	$find4 = StringRegExp($aCfgArray[$a], "(.*phase2ss\s=\s.*;)", 0, 1)
	If $find4 = 1 Then
		$aCfgArray[$a] = StringReplace($aCfgArray[$a], "pfs" & Chr(34) & ";", "no-pfs" & Chr(34) & ";", 1, 1)
		If @extended = 1 Then $done = $done + 1
	EndIf
	; Zeilen in der Sektion phase2localid ersetzen
	$find5 = StringRegExp($aCfgArray[$a], "(.*phase2localid\s\{)", 0, 1)
	If $find5 = 1 Then
		$aCfgArray[$a + 2] = "                                ipaddr = 0.0.0.0;"
		$aCfgArray[$a + 3] = "                                mask = 0.0.0.0;"
		$done = $done + 1
	EndIf
	;permit ip ndern (falls erwnscht)
	If $iMsgBoxAnswer = 6 Then ;Yes
		$aCfgArray[$a] = StringRegExpReplace($aCfgArray[$a], "(.*permit\sip\s)([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\s[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\s)(.*)", "${1}0.0.0.0 0.0.0.0 ${3}", 0)
	EndIf
Next


;array ins neue File schreiben
If $done = 5 Then
	_FileWriteFromArray($sCFGFileout, $aCfgArray, 1)
	$done = 0
Else
	MsgBox(0, "Error", "Einige Ersetzungen konnten nicht vorgenommen werden!" & @CRLF & "Programm bricht hier ab!")
	Exit 6
EndIf
;_ArrayDisplay($aCfgArray)
MsgBox(262208, "Information", "Die Datei " & $sCFGFileout & " ist nun iOS-tauglich." & @CRLF & "Spielen sie nun diese Konfiguration in ihre FRITZ!Box ein!")